ace.define("ace/mode/python_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],(function(require,exports,module){"use strict";var oop=require("../lib/oop"),TextHighlightRules=require("./text_highlight_rules").TextHighlightRules,PythonHighlightRules=function(){var keywordMapper=this.createKeywordMapper({"invalid.deprecated":"debugger","support.function":"abs|divmod|input|open|staticmethod|all|enumerate|int|ord|str|any|eval|isinstance|pow|sum|basestring|execfile|issubclass|print|super|binfile|bin|iter|property|tuple|bool|filter|len|range|type|bytearray|float|list|raw_input|unichr|callable|format|locals|reduce|unicode|chr|frozenset|long|reload|vars|classmethod|getattr|map|repr|xrange|cmp|globals|max|reversed|zip|compile|hasattr|memoryview|round|__import__|complex|hash|min|apply|delattr|help|next|setattr|set|buffer|dict|hex|object|slice|coerce|dir|id|oct|sorted|intern|ascii|breakpoint|bytes","variable.language":"self|cls","constant.language":"True|False|None|NotImplemented|Ellipsis|__debug__",keyword:"and|as|assert|break|class|continue|def|del|elif|else|except|exec|finally|for|from|global|if|import|in|is|lambda|not|or|pass|print|raise|return|try|while|with|yield|async|await|nonlocal"},"identifier"),integer="(?:(?:(?:[1-9]\\d*)|(?:0))|(?:0[oO]?[0-7]+)|(?:0[xX][\\dA-Fa-f]+)|(?:0[bB][01]+))",pointFloat="(?:(?:(?:\\d+)?(?:\\.\\d+))|(?:(?:\\d+)\\.))",floatNumber="(?:(?:(?:(?:(?:(?:\\d+)?(?:\\.\\d+))|(?:(?:\\d+)\\.))|(?:\\d+))(?:[eE][+-]?\\d+))|"+pointFloat+")",stringEscape="\\\\(x[0-9A-Fa-f]{2}|[0-7]{3}|[\\\\abfnrtv'\"]|U[0-9A-Fa-f]{8}|u[0-9A-Fa-f]{4})";this.$rules={start:[{token:"comment",regex:"#.*$"},{token:"string",regex:'[uU]?"{3}',next:"qqstring3"},{token:"string",regex:'[uU]?"(?=.)',next:"qqstring"},{token:"string",regex:"[uU]?'{3}",next:"qstring3"},{token:"string",regex:"[uU]?'(?=.)",next:"qstring"},{token:"string",regex:'[rR]"{3}',next:"rawqqstring3"},{token:"string",regex:'[rR]"(?=.)',next:"rawqqstring"},{token:"string",regex:"[rR]'{3}",next:"rawqstring3"},{token:"string",regex:"[rR]'(?=.)",next:"rawqstring"},{token:"string",regex:'[fF]"{3}',next:"fqqstring3"},{token:"string",regex:'[fF]"(?=.)',next:"fqqstring"},{token:"string",regex:"[fF]'{3}",next:"fqstring3"},{token:"string",regex:"[fF]'(?=.)",next:"fqstring"},{token:"string",regex:'(?:[rR][fF]|[fF][rR])"{3}',next:"rfqqstring3"},{token:"string",regex:'(?:[rR][fF]|[fF][rR])"(?=.)',next:"rfqqstring"},{token:"string",regex:"(?:[rR][fF]|[fF][rR])'{3}",next:"rfqstring3"},{token:"string",regex:"(?:[rR][fF]|[fF][rR])'(?=.)",next:"rfqstring"},{token:"keyword.operator",regex:"\\+|\\-|\\*|\\*\\*|\\/|\\/\\/|%|@|<<|>>|&|\\||\\^|~|<|>|<=|=>|==|!=|<>|="},{token:"punctuation",regex:",|:|;|\\->|\\+=|\\-=|\\*=|\\/=|\\/\\/=|%=|@=|&=|\\|=|^=|>>=|<<=|\\*\\*="},{token:"paren.lparen",regex:"[\\[\\(\\{]"},{token:"paren.rparen",regex:"[\\]\\)\\}]"},{token:"text",regex:"\\s+"},{include:"constants"}],qqstring3:[{token:"constant.language.escape",regex:stringEscape},{token:"string",regex:'"{3}',next:"start"},{defaultToken:"string"}],qstring3:[{token:"constant.language.escape",regex:stringEscape},{token:"string",regex:"'{3}",next:"start"},{defaultToken:"string"}],qqstring:[{token:"constant.language.escape",regex:stringEscape},{token:"string",regex:"\\\\$",next:"qqstring"},{token:"string",regex:'"|$',next:"start"},{defaultToken:"string"}],qstring:[{token:"constant.language.escape",regex:stringEscape},{token:"string",regex:"\\\\$",next:"qstring"},{token:"string",regex:"'|$",next:"start"},{defaultToken:"string"}],rawqqstring3:[{token:"string",regex:'"{3}',next:"start"},{defaultToken:"string"}],rawqstring3:[{token:"string",regex:"'{3}",next:"start"},{defaultToken:"string"}],rawqqstring:[{token:"string",regex:"\\\\$",next:"rawqqstring"},{token:"string",regex:'"|$',next:"start"},{defaultToken:"string"}],rawqstring:[{token:"string",regex:"\\\\$",next:"rawqstring"},{token:"string",regex:"'|$",next:"start"},{defaultToken:"string"}],fqqstring3:[{token:"constant.language.escape",regex:stringEscape},{token:"string",regex:'"{3}',next:"start"},{token:"paren.lparen",regex:"{",push:"fqstringParRules"},{defaultToken:"string"}],fqstring3:[{token:"constant.language.escape",regex:stringEscape},{token:"string",regex:"'{3}",next:"start"},{token:"paren.lparen",regex:"{",push:"fqstringParRules"},{defaultToken:"string"}],fqqstring:[{token:"constant.language.escape",regex:stringEscape},{token:"string",regex:"\\\\$",next:"fqqstring"},{token:"string",regex:'"|$',next:"start"},{token:"paren.lparen",regex:"{",push:"fqstringParRules"},{defaultToken:"string"}],fqstring:[{token:"constant.language.escape",regex:stringEscape},{token:"string",regex:"'|$",next:"start"},{token:"paren.lparen",regex:"{",push:"fqstringParRules"},{defaultToken:"string"}],rfqqstring3:[{token:"string",regex:'"{3}',next:"start"},{token:"paren.lparen",regex:"{",push:"fqstringParRules"},{defaultToken:"string"}],rfqstring3:[{token:"string",regex:"'{3}",next:"start"},{token:"paren.lparen",regex:"{",push:"fqstringParRules"},{defaultToken:"string"}],rfqqstring:[{token:"string",regex:"\\\\$",next:"rfqqstring"},{token:"string",regex:'"|$',next:"start"},{token:"paren.lparen",regex:"{",push:"fqstringParRules"},{defaultToken:"string"}],rfqstring:[{token:"string",regex:"'|$",next:"start"},{token:"paren.lparen",regex:"{",push:"fqstringParRules"},{defaultToken:"string"}],fqstringParRules:[{token:"paren.lparen",regex:"[\\[\\(]"},{token:"paren.rparen",regex:"[\\]\\)]"},{token:"string",regex:"\\s+"},{token:"string",regex:"'[^']*'"},{token:"string",regex:'"[^"]*"'},{token:"function.support",regex:"(!s|!r|!a)"},{include:"constants"},{token:"paren.rparen",regex:"}",next:"pop"},{token:"paren.lparen",regex:"{",push:"fqstringParRules"}],constants:[{token:"constant.numeric",regex:"(?:"+floatNumber+"|\\d+)[jJ]\\b"},{token:"constant.numeric",regex:floatNumber},{token:"constant.numeric",regex:integer+"[lL]\\b"},{token:"constant.numeric",regex:integer+"\\b"},{token:["punctuation","function.support"],regex:"(\\.)([a-zA-Z_]+)\\b"},{token:keywordMapper,regex:"[a-zA-Z_$][a-zA-Z0-9_$]*\\b"}]},this.normalizeRules()};oop.inherits(PythonHighlightRules,TextHighlightRules),exports.PythonHighlightRules=PythonHighlightRules})),ace.define("ace/mode/folding/pythonic",["require","exports","module","ace/lib/oop","ace/mode/folding/fold_mode"],(function(require,exports,module){"use strict";var oop=require("../../lib/oop"),BaseFoldMode=require("./fold_mode").FoldMode,FoldMode=exports.FoldMode=function(markers){this.foldingStartMarker=new RegExp("([\\[{])(?:\\s*)$|("+markers+")(?:\\s*)(?:#.*)?$")};oop.inherits(FoldMode,BaseFoldMode),function(){this.getFoldWidgetRange=function(session,foldStyle,row){var match=session.getLine(row).match(this.foldingStartMarker);if(match)return match[1]?this.openingBracketBlock(session,match[1],row,match.index):match[2]?this.indentationBlock(session,row,match.index+match[2].length):this.indentationBlock(session,row)}}.call(FoldMode.prototype)})),ace.define("ace/mode/python",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/python_highlight_rules","ace/mode/folding/pythonic","ace/range"],(function(require,exports,module){"use strict";var oop=require("../lib/oop"),TextMode=require("./text").Mode,PythonHighlightRules=require("./python_highlight_rules").PythonHighlightRules,PythonFoldMode=require("./folding/pythonic").FoldMode,Range=require("../range").Range,Mode=function(){this.HighlightRules=PythonHighlightRules,this.foldingRules=new PythonFoldMode("\\:"),this.$behaviour=this.$defaultBehaviour};oop.inherits(Mode,TextMode),function(){this.lineCommentStart="#",this.getNextLineIndent=function(state,line,tab){var indent=this.$getIndent(line),tokens=this.getTokenizer().getLineTokens(line,state).tokens;if(tokens.length&&"comment"==tokens[tokens.length-1].type)return indent;"start"==state&&(line.match(/^.*[\{\(\[:]\s*$/)&&(indent+=tab));return indent};var outdents={pass:1,return:1,raise:1,break:1,continue:1};this.checkOutdent=function(state,line,input){if("\r\n"!==input&&"\r"!==input&&"\n"!==input)return!1;var tokens=this.getTokenizer().getLineTokens(line.trim(),state).tokens;if(!tokens)return!1;do{var last=tokens.pop()}while(last&&("comment"==last.type||"text"==last.type&&last.value.match(/^\s+$/)));return!!last&&("keyword"==last.type&&outdents[last.value])},this.autoOutdent=function(state,doc,row){row+=1;var indent=this.$getIndent(doc.getLine(row)),tab=doc.getTabString();indent.slice(-tab.length)==tab&&doc.remove(new Range(row,indent.length-tab.length,row,indent.length))},this.$id="ace/mode/python",this.snippetFileId="ace/snippets/python"}.call(Mode.prototype),exports.Mode=Mode})),ace.require(["ace/mode/python"],(function(m){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=m)}));