ace.define("ace/occur",["require","exports","module","ace/lib/oop","ace/range","ace/search","ace/edit_session","ace/search_highlight","ace/lib/dom"],(function(require,exports,module){"use strict";var oop=require("./lib/oop"),Search=(require("./range").Range,require("./search").Search),EditSession=require("./edit_session").EditSession,SearchHighlight=require("./search_highlight").SearchHighlight;function Occur(){}oop.inherits(Occur,Search),function(){this.enter=function(editor,options){if(!options.needle)return!1;var pos=editor.getCursorPosition();this.displayOccurContent(editor,options);var translatedPos=this.originalToOccurPosition(editor.session,pos);return editor.moveCursorToPosition(translatedPos),!0},this.exit=function(editor,options){var pos=options.translatePosition&&editor.getCursorPosition(),translatedPos=pos&&this.occurToOriginalPosition(editor.session,pos);return this.displayOriginalContent(editor),translatedPos&&editor.moveCursorToPosition(translatedPos),!0},this.highlight=function(sess,regexp){(sess.$occurHighlight=sess.$occurHighlight||sess.addDynamicMarker(new SearchHighlight(null,"ace_occur-highlight","text"))).setRegexp(regexp),sess._emit("changeBackMarker")},this.displayOccurContent=function(editor,options){this.$originalSession=editor.session;var found=this.matchingLines(editor.session,options),lines=found.map((function(foundLine){return foundLine.content})),occurSession=new EditSession(lines.join("\n"));occurSession.$occur=this,occurSession.$occurMatchingLines=found,editor.setSession(occurSession),this.$useEmacsStyleLineStart=this.$originalSession.$useEmacsStyleLineStart,occurSession.$useEmacsStyleLineStart=this.$useEmacsStyleLineStart,this.highlight(occurSession,options.re),occurSession._emit("changeBackMarker")},this.displayOriginalContent=function(editor){editor.setSession(this.$originalSession),this.$originalSession.$useEmacsStyleLineStart=this.$useEmacsStyleLineStart},this.originalToOccurPosition=function(session,pos){var lines=session.$occurMatchingLines,nullPos={row:0,column:0};if(!lines)return nullPos;for(var i=0;i<lines.length;i++)if(lines[i].row===pos.row)return{row:i,column:pos.column};return nullPos},this.occurToOriginalPosition=function(session,pos){var lines=session.$occurMatchingLines;return lines&&lines[pos.row]?{row:lines[pos.row].row,column:pos.column}:pos},this.matchingLines=function(session,options){if(options=oop.mixin({},options),!session||!options.needle)return[];var search=new Search;return search.set(options),search.findAll(session).reduce((function(lines,range){var row=range.start.row,last=lines[lines.length-1];return last&&last.row===row?lines:lines.concat({row,content:session.getLine(row)})}),[])}}.call(Occur.prototype),require("./lib/dom").importCssString(".ace_occur-highlight {\n    border-radius: 4px;\n    background-color: rgba(87, 255, 8, 0.25);\n    position: absolute;\n    z-index: 4;\n    box-sizing: border-box;\n    box-shadow: 0 0 4px rgb(91, 255, 50);\n}\n.ace_dark .ace_occur-highlight {\n    background-color: rgb(80, 140, 85);\n    box-shadow: 0 0 4px rgb(60, 120, 70);\n}\n","incremental-occur-highlighting"),exports.Occur=Occur})),ace.define("ace/commands/occur_commands",["require","exports","module","ace/config","ace/occur","ace/keyboard/hash_handler","ace/lib/oop"],(function(require,exports,module){require("../config");var Occur=require("../occur").Occur,occurStartCommand={name:"occur",exec:function(editor,options){var alreadyInOccur=!!editor.session.$occur;(new Occur).enter(editor,options)&&!alreadyInOccur&&OccurKeyboardHandler.installIn(editor)},readOnly:!0},occurCommands=[{name:"occurexit",bindKey:"esc|Ctrl-G",exec:function(editor){var occur=editor.session.$occur;occur&&(occur.exit(editor,{}),editor.session.$occur||OccurKeyboardHandler.uninstallFrom(editor))},readOnly:!0},{name:"occuraccept",bindKey:"enter",exec:function(editor){var occur=editor.session.$occur;occur&&(occur.exit(editor,{translatePosition:!0}),editor.session.$occur||OccurKeyboardHandler.uninstallFrom(editor))},readOnly:!0}],HashHandler=require("../keyboard/hash_handler").HashHandler;function OccurKeyboardHandler(){}require("../lib/oop").inherits(OccurKeyboardHandler,HashHandler),function(){this.isOccurHandler=!0,this.attach=function(editor){HashHandler.call(this,occurCommands,editor.commands.platform),this.$editor=editor};var handleKeyboard$super=this.handleKeyboard;this.handleKeyboard=function(data,hashId,key,keyCode){var cmd=handleKeyboard$super.call(this,data,hashId,key,keyCode);return cmd&&cmd.command?cmd:void 0}}.call(OccurKeyboardHandler.prototype),OccurKeyboardHandler.installIn=function(editor){var handler=new this;editor.keyBinding.addKeyboardHandler(handler),editor.commands.addCommands(occurCommands)},OccurKeyboardHandler.uninstallFrom=function(editor){editor.commands.removeCommands(occurCommands);var handler=editor.getKeyboardHandler();handler.isOccurHandler&&editor.keyBinding.removeKeyboardHandler(handler)},exports.occurStartCommand=occurStartCommand})),ace.define("ace/commands/incremental_search_commands",["require","exports","module","ace/config","ace/lib/oop","ace/keyboard/hash_handler","ace/commands/occur_commands"],(function(require,exports,module){var config=require("../config"),oop=require("../lib/oop"),HashHandler=require("../keyboard/hash_handler").HashHandler,occurStartCommand=require("./occur_commands").occurStartCommand;function IncrementalSearchKeyboardHandler(iSearch){this.$iSearch=iSearch}exports.iSearchStartCommands=[{name:"iSearch",bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(editor,options){config.loadModule(["core","ace/incremental_search"],(function(e){var iSearch=e.iSearch=e.iSearch||new e.IncrementalSearch;iSearch.activate(editor,options.backwards),options.jumpToFirstMatch&&iSearch.next(options)}))},readOnly:!0},{name:"iSearchBackwards",exec:function(editor,jumpToNext){editor.execCommand("iSearch",{backwards:!0})},readOnly:!0},{name:"iSearchAndGo",bindKey:{win:"Ctrl-K",mac:"Command-G"},exec:function(editor,jumpToNext){editor.execCommand("iSearch",{jumpToFirstMatch:!0,useCurrentOrPrevSearch:!0})},readOnly:!0},{name:"iSearchBackwardsAndGo",bindKey:{win:"Ctrl-Shift-K",mac:"Command-Shift-G"},exec:function(editor){editor.execCommand("iSearch",{jumpToFirstMatch:!0,backwards:!0,useCurrentOrPrevSearch:!0})},readOnly:!0}],exports.iSearchCommands=[{name:"restartSearch",bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(iSearch){iSearch.cancelSearch(!0)}},{name:"searchForward",bindKey:{win:"Ctrl-S|Ctrl-K",mac:"Ctrl-S|Command-G"},exec:function(iSearch,options){options.useCurrentOrPrevSearch=!0,iSearch.next(options)}},{name:"searchBackward",bindKey:{win:"Ctrl-R|Ctrl-Shift-K",mac:"Ctrl-R|Command-Shift-G"},exec:function(iSearch,options){options.useCurrentOrPrevSearch=!0,options.backwards=!0,iSearch.next(options)}},{name:"extendSearchTerm",exec:function(iSearch,string){iSearch.addString(string)}},{name:"extendSearchTermSpace",bindKey:"space",exec:function(iSearch){iSearch.addString(" ")}},{name:"shrinkSearchTerm",bindKey:"backspace",exec:function(iSearch){iSearch.removeChar()}},{name:"confirmSearch",bindKey:"return",exec:function(iSearch){iSearch.deactivate()}},{name:"cancelSearch",bindKey:"esc|Ctrl-G",exec:function(iSearch){iSearch.deactivate(!0)}},{name:"occurisearch",bindKey:"Ctrl-O",exec:function(iSearch){var options=oop.mixin({},iSearch.$options);iSearch.deactivate(),occurStartCommand.exec(iSearch.$editor,options)}},{name:"yankNextWord",bindKey:"Ctrl-w",exec:function(iSearch){var ed=iSearch.$editor,range=ed.selection.getRangeOfMovements((function(sel){sel.moveCursorWordRight()})),string=ed.session.getTextRange(range);iSearch.addString(string)}},{name:"yankNextChar",bindKey:"Ctrl-Alt-y",exec:function(iSearch){var ed=iSearch.$editor,range=ed.selection.getRangeOfMovements((function(sel){sel.moveCursorRight()})),string=ed.session.getTextRange(range);iSearch.addString(string)}},{name:"recenterTopBottom",bindKey:"Ctrl-l",exec:function(iSearch){iSearch.$editor.execCommand("recenterTopBottom")}},{name:"selectAllMatches",bindKey:"Ctrl-space",exec:function(iSearch){var ed=iSearch.$editor,hl=ed.session.$isearchHighlight,ranges=hl&&hl.cache?hl.cache.reduce((function(ranges,ea){return ranges.concat(ea||[])}),[]):[];iSearch.deactivate(!1),ranges.forEach(ed.selection.addRange.bind(ed.selection))}},{name:"searchAsRegExp",bindKey:"Alt-r",exec:function(iSearch){iSearch.convertNeedleToRegExp()}}].map((function(cmd){return cmd.readOnly=!0,cmd.isIncrementalSearchCommand=!0,cmd.scrollIntoView="animate-cursor",cmd})),oop.inherits(IncrementalSearchKeyboardHandler,HashHandler),function(){this.attach=function(editor){var iSearch=this.$iSearch;HashHandler.call(this,exports.iSearchCommands,editor.commands.platform),this.$commandExecHandler=editor.commands.on("exec",(function(e){if(!e.command.isIncrementalSearchCommand)return iSearch.deactivate();e.stopPropagation(),e.preventDefault();var scrollTop=editor.session.getScrollTop(),result=e.command.exec(iSearch,e.args||{});return editor.renderer.scrollCursorIntoView(null,.5),editor.renderer.animateScrolling(scrollTop),result}))},this.detach=function(editor){this.$commandExecHandler&&(editor.commands.off("exec",this.$commandExecHandler),delete this.$commandExecHandler)};var handleKeyboard$super=this.handleKeyboard;this.handleKeyboard=function(data,hashId,key,keyCode){if((1===hashId||8===hashId)&&"v"===key||1===hashId&&"y"===key)return null;var cmd=handleKeyboard$super.call(this,data,hashId,key,keyCode);if(cmd&&cmd.command)return cmd;if(-1==hashId){var extendCmd=this.commands.extendSearchTerm;if(extendCmd)return{command:extendCmd,args:key}}return!1}}.call(IncrementalSearchKeyboardHandler.prototype),exports.IncrementalSearchKeyboardHandler=IncrementalSearchKeyboardHandler})),ace.define("ace/incremental_search",["require","exports","module","ace/lib/oop","ace/range","ace/search","ace/search_highlight","ace/commands/incremental_search_commands","ace/lib/dom","ace/commands/command_manager","ace/editor","ace/config"],(function(require,exports,module){"use strict";var oop=require("./lib/oop"),Range=require("./range").Range,Search=require("./search").Search,SearchHighlight=require("./search_highlight").SearchHighlight,iSearchCommandModule=require("./commands/incremental_search_commands"),ISearchKbd=iSearchCommandModule.IncrementalSearchKeyboardHandler;function IncrementalSearch(){this.$options={wrap:!1,skipCurrent:!1},this.$keyboardHandler=new ISearchKbd(this)}function isRegExp(obj){return obj instanceof RegExp}function regExpToObject(re){var string=String(re),start=string.indexOf("/"),flagStart=string.lastIndexOf("/");return{expression:string.slice(start+1,flagStart),flags:string.slice(flagStart+1)}}function stringToRegExp(string,flags){try{return new RegExp(string,flags)}catch(e){return string}}function objectToRegExp(obj){return stringToRegExp(obj.expression,obj.flags)}oop.inherits(IncrementalSearch,Search),function(){this.activate=function(editor,backwards){this.$editor=editor,this.$startPos=this.$currentPos=editor.getCursorPosition(),this.$options.needle="",this.$options.backwards=backwards,editor.keyBinding.addKeyboardHandler(this.$keyboardHandler),this.$originalEditorOnPaste=editor.onPaste,editor.onPaste=this.onPaste.bind(this),this.$mousedownHandler=editor.on("mousedown",this.onMouseDown.bind(this)),this.selectionFix(editor),this.statusMessage(!0)},this.deactivate=function(reset){this.cancelSearch(reset);var editor=this.$editor;editor.keyBinding.removeKeyboardHandler(this.$keyboardHandler),this.$mousedownHandler&&(editor.off("mousedown",this.$mousedownHandler),delete this.$mousedownHandler),editor.onPaste=this.$originalEditorOnPaste,this.message("")},this.selectionFix=function(editor){editor.selection.isEmpty()&&!editor.session.$emacsMark&&editor.clearSelection()},this.highlight=function(regexp){var sess=this.$editor.session;(sess.$isearchHighlight=sess.$isearchHighlight||sess.addDynamicMarker(new SearchHighlight(null,"ace_isearch-result","text"))).setRegexp(regexp),sess._emit("changeBackMarker")},this.cancelSearch=function(reset){var e=this.$editor;return this.$prevNeedle=this.$options.needle,this.$options.needle="",reset?(e.moveCursorToPosition(this.$startPos),this.$currentPos=this.$startPos):e.pushEmacsMark&&e.pushEmacsMark(this.$startPos,!1),this.highlight(null),Range.fromPoints(this.$currentPos,this.$currentPos)},this.highlightAndFindWithNeedle=function(moveToNext,needleUpdateFunc){if(!this.$editor)return null;var options=this.$options;if(needleUpdateFunc&&(options.needle=needleUpdateFunc.call(this,options.needle||"")||""),0===options.needle.length)return this.statusMessage(!0),this.cancelSearch(!0);options.start=this.$currentPos;var session=this.$editor.session,found=this.find(session),shouldSelect=this.$editor.emacsMark?!!this.$editor.emacsMark():!this.$editor.selection.isEmpty();return found&&(options.backwards&&(found=Range.fromPoints(found.end,found.start)),this.$editor.selection.setRange(Range.fromPoints(shouldSelect?this.$startPos:found.end,found.end)),moveToNext&&(this.$currentPos=found.end),this.highlight(options.re)),this.statusMessage(found),found},this.addString=function(s){return this.highlightAndFindWithNeedle(!1,(function(needle){if(!isRegExp(needle))return needle+s;var reObj=regExpToObject(needle);return reObj.expression+=s,objectToRegExp(reObj)}))},this.removeChar=function(c){return this.highlightAndFindWithNeedle(!1,(function(needle){if(!isRegExp(needle))return needle.substring(0,needle.length-1);var reObj=regExpToObject(needle);return reObj.expression=reObj.expression.substring(0,reObj.expression.length-1),objectToRegExp(reObj)}))},this.next=function(options){return options=options||{},this.$options.backwards=!!options.backwards,this.$currentPos=this.$editor.getCursorPosition(),this.highlightAndFindWithNeedle(!0,(function(needle){return options.useCurrentOrPrevSearch&&0===needle.length?this.$prevNeedle||"":needle}))},this.onMouseDown=function(evt){return this.deactivate(),!0},this.onPaste=function(text){this.addString(text)},this.convertNeedleToRegExp=function(){return this.highlightAndFindWithNeedle(!1,(function(needle){return isRegExp(needle)?needle:stringToRegExp(needle,"ig")}))},this.convertNeedleToString=function(){return this.highlightAndFindWithNeedle(!1,(function(needle){return isRegExp(needle)?regExpToObject(needle).expression:needle}))},this.statusMessage=function(found){var options=this.$options,msg="";msg+=options.backwards?"reverse-":"",msg+="isearch: "+options.needle,msg+=found?"":" (not found)",this.message(msg)},this.message=function(msg){this.$editor.showCommandLine&&(this.$editor.showCommandLine(msg),this.$editor.focus())}}.call(IncrementalSearch.prototype),exports.IncrementalSearch=IncrementalSearch;var dom=require("./lib/dom");dom.importCssString&&dom.importCssString(".ace_marker-layer .ace_isearch-result {  position: absolute;  z-index: 6;  box-sizing: border-box;}div.ace_isearch-result {  border-radius: 4px;  background-color: rgba(255, 200, 0, 0.5);  box-shadow: 0 0 4px rgb(255, 200, 0);}.ace_dark div.ace_isearch-result {  background-color: rgb(100, 110, 160);  box-shadow: 0 0 4px rgb(80, 90, 140);}","incremental-search-highlighting");var commands=require("./commands/command_manager");(function(){this.setupIncrementalSearch=function(editor,val){if(this.usesIncrementalSearch!=val){this.usesIncrementalSearch=val;var iSearchCommands=iSearchCommandModule.iSearchStartCommands;this[val?"addCommands":"removeCommands"](iSearchCommands)}}}).call(commands.CommandManager.prototype);var Editor=require("./editor").Editor;require("./config").defineOptions(Editor.prototype,"editor",{useIncrementalSearch:{set:function(val){this.keyBinding.$handlers.forEach((function(handler){handler.setupIncrementalSearch&&handler.setupIncrementalSearch(this,val)})),this._emit("incrementalSearchSettingChanged",{isEnabled:val})}}})})),ace.define("ace/keyboard/emacs",["require","exports","module","ace/lib/dom","ace/incremental_search","ace/commands/incremental_search_commands","ace/keyboard/hash_handler","ace/lib/keys"],(function(require,exports,module){"use strict";var dom=require("../lib/dom");require("../incremental_search");var iSearchCommandModule=require("../commands/incremental_search_commands"),HashHandler=require("./hash_handler").HashHandler;exports.handler=new HashHandler,exports.handler.isEmacs=!0,exports.handler.$id="ace/keyboard/emacs";var $formerLongWords,$formerLineStart,initialized=!1;exports.handler.attach=function(editor){initialized||(initialized=!0,dom.importCssString("            .emacs-mode .ace_cursor{                border: 1px rgba(50,250,50,0.8) solid!important;                box-sizing: border-box!important;                background-color: rgba(0,250,0,0.9);                opacity: 0.5;            }            .emacs-mode .ace_hidden-cursors .ace_cursor{                opacity: 1;                background-color: transparent;            }            .emacs-mode .ace_overwrite-cursors .ace_cursor {                opacity: 1;                background-color: transparent;                border-width: 0 0 2px 2px !important;            }            .emacs-mode .ace_text-layer {                z-index: 4            }            .emacs-mode .ace_cursor-layer {                z-index: 2            }","emacsMode")),$formerLongWords=editor.session.$selectLongWords,editor.session.$selectLongWords=!0,$formerLineStart=editor.session.$useEmacsStyleLineStart,editor.session.$useEmacsStyleLineStart=!0,editor.session.$emacsMark=null,editor.session.$emacsMarkRing=editor.session.$emacsMarkRing||[],editor.emacsMark=function(){return this.session.$emacsMark},editor.setEmacsMark=function(p){this.session.$emacsMark=p},editor.pushEmacsMark=function(p,activate){var prevMark=this.session.$emacsMark;prevMark&&this.session.$emacsMarkRing.push(prevMark),!p||activate?this.setEmacsMark(p):this.session.$emacsMarkRing.push(p)},editor.popEmacsMark=function(){var mark=this.emacsMark();return mark?(this.setEmacsMark(null),mark):this.session.$emacsMarkRing.pop()},editor.getLastEmacsMark=function(p){return this.session.$emacsMark||this.session.$emacsMarkRing.slice(-1)[0]},editor.emacsMarkForSelection=function(replacement){var sel=this.selection,multiRangeLength=this.multiSelect?this.multiSelect.getAllRanges().length:1,selIndex=sel.index||0,markRing=this.session.$emacsMarkRing,markIndex=markRing.length-(multiRangeLength-selIndex),lastMark=markRing[markIndex]||sel.anchor;return replacement&&markRing.splice(markIndex,1,"row"in replacement&&"column"in replacement?replacement:void 0),lastMark},editor.on("click",$resetMarkMode),editor.on("changeSession",$kbSessionChange),editor.renderer.$blockCursor=!0,editor.setStyle("emacs-mode"),editor.commands.addCommands(commands),exports.handler.platform=editor.commands.platform,editor.$emacsModeHandler=this,editor.on("copy",this.onCopy),editor.on("paste",this.onPaste)},exports.handler.detach=function(editor){editor.renderer.$blockCursor=!1,editor.session.$selectLongWords=$formerLongWords,editor.session.$useEmacsStyleLineStart=$formerLineStart,editor.off("click",$resetMarkMode),editor.off("changeSession",$kbSessionChange),editor.unsetStyle("emacs-mode"),editor.commands.removeCommands(commands),editor.off("copy",this.onCopy),editor.off("paste",this.onPaste),editor.$emacsModeHandler=null};var $kbSessionChange=function(e){e.oldSession&&(e.oldSession.$selectLongWords=$formerLongWords,e.oldSession.$useEmacsStyleLineStart=$formerLineStart),$formerLongWords=e.session.$selectLongWords,e.session.$selectLongWords=!0,$formerLineStart=e.session.$useEmacsStyleLineStart,e.session.$useEmacsStyleLineStart=!0,e.session.hasOwnProperty("$emacsMark")||(e.session.$emacsMark=null),e.session.hasOwnProperty("$emacsMarkRing")||(e.session.$emacsMarkRing=[])},$resetMarkMode=function(e){e.editor.session.$emacsMark=null},keys=require("../lib/keys").KEY_MODS,eMods={C:"ctrl",S:"shift",M:"alt",CMD:"command"};["C-S-M-CMD","S-M-CMD","C-M-CMD","C-S-CMD","C-S-M","M-CMD","S-CMD","S-M","C-CMD","C-M","C-S","CMD","M","S","C"].forEach((function(c){var hashId=0;c.split("-").forEach((function(c){hashId|=keys[eMods[c]]})),eMods[hashId]=c.toLowerCase()+"-"})),exports.handler.onCopy=function(e,editor){editor.$handlesEmacsOnCopy||(editor.$handlesEmacsOnCopy=!0,exports.handler.commands.killRingSave.exec(editor),editor.$handlesEmacsOnCopy=!1)},exports.handler.onPaste=function(e,editor){editor.pushEmacsMark(editor.getCursorPosition())},exports.handler.bindKey=function(key,command){if("object"==typeof key&&(key=key[this.platform]),key){var ckb=this.commandKeyBinding;key.split("|").forEach((function(keyPart){keyPart=keyPart.toLowerCase(),ckb[keyPart]=command,keyPart.split(" ").slice(0,-1).reduce((function(keyMapKeys,keyPart,i){var prefix=keyMapKeys[i-1]?keyMapKeys[i-1]+" ":"";return keyMapKeys.concat([prefix+keyPart])}),[]).forEach((function(keyPart){ckb[keyPart]||(ckb[keyPart]="null")}))}),this)}},exports.handler.getStatusText=function(editor,data){var str="";return data.count&&(str+=data.count),data.keyChain&&(str+=" "+data.keyChain),str},exports.handler.handleKeyboard=function(data,hashId,key,keyCode){if(-1!==keyCode){var editor=data.editor;if(editor._signal("changeStatus"),-1==hashId&&(editor.pushEmacsMark(),data.count)){var str=new Array(data.count+1).join(key);return data.count=null,{command:"insertstring",args:str}}var modifier=eMods[hashId];if("c-"==modifier||data.count)if("number"==typeof(count=parseInt(key[key.length-1]))&&!isNaN(count))return data.count=Math.max(data.count,0)||0,data.count=10*data.count+count,{command:"null"};modifier&&(key=modifier+key),data.keyChain&&(key=data.keyChain+=" "+key);var command=this.commandKeyBinding[key];if(data.keyChain="null"==command?key:"",command){if("null"===command)return{command:"null"};if("universalArgument"===command)return data.count=-4,{command:"null"};var args;if("string"!=typeof command&&(args=command.args,command.command&&(command=command.command),"goorselect"===command&&(command=editor.emacsMark()?args[1]:args[0],args=null)),"string"!=typeof command||("insertstring"!==command&&"splitline"!==command&&"togglecomment"!==command||editor.pushEmacsMark(),command=this.commands[command]||editor.commands.commands[command])){if(command.readOnly||command.isYank||(data.lastCommand=null),!command.readOnly&&editor.emacsMark()&&editor.setEmacsMark(null),data.count){var count=data.count;if(data.count=0,!command||!command.handlesCount)return{args,command:{exec:function(editor,args){for(var i=0;i<count;i++)command.exec(editor,args)},multiSelectAction:command.multiSelectAction}};args||(args={}),"object"==typeof args&&(args.count=count)}return{command,args}}}}},exports.emacsKeys={"Up|C-p":{command:"goorselect",args:["golineup","selectup"]},"Down|C-n":{command:"goorselect",args:["golinedown","selectdown"]},"Left|C-b":{command:"goorselect",args:["gotoleft","selectleft"]},"Right|C-f":{command:"goorselect",args:["gotoright","selectright"]},"C-Left|M-b":{command:"goorselect",args:["gotowordleft","selectwordleft"]},"C-Right|M-f":{command:"goorselect",args:["gotowordright","selectwordright"]},"Home|C-a":{command:"goorselect",args:["gotolinestart","selecttolinestart"]},"End|C-e":{command:"goorselect",args:["gotolineend","selecttolineend"]},"C-Home|S-M-,":{command:"goorselect",args:["gotostart","selecttostart"]},"C-End|S-M-.":{command:"goorselect",args:["gotoend","selecttoend"]},"S-Up|S-C-p":"selectup","S-Down|S-C-n":"selectdown","S-Left|S-C-b":"selectleft","S-Right|S-C-f":"selectright","S-C-Left|S-M-b":"selectwordleft","S-C-Right|S-M-f":"selectwordright","S-Home|S-C-a":"selecttolinestart","S-End|S-C-e":"selecttolineend","S-C-Home":"selecttostart","S-C-End":"selecttoend","C-l":"recenterTopBottom","M-s":"centerselection","M-g":"gotoline","C-x C-p":"selectall","C-Down":{command:"goorselect",args:["gotopagedown","selectpagedown"]},"C-Up":{command:"goorselect",args:["gotopageup","selectpageup"]},"PageDown|C-v":{command:"goorselect",args:["gotopagedown","selectpagedown"]},"PageUp|M-v":{command:"goorselect",args:["gotopageup","selectpageup"]},"S-C-Down":"selectpagedown","S-C-Up":"selectpageup","C-s":"iSearch","C-r":"iSearchBackwards","M-C-s":"findnext","M-C-r":"findprevious","S-M-5":"replace",Backspace:"backspace","Delete|C-d":"del","Return|C-m":{command:"insertstring",args:"\n"},"C-o":"splitline","M-d|C-Delete":{command:"killWord",args:"right"},"C-Backspace|M-Backspace|M-Delete":{command:"killWord",args:"left"},"C-k":"killLine","C-y|S-Delete":"yank","M-y":"yankRotate","C-g":"keyboardQuit","C-w|C-S-W":"killRegion","M-w":"killRingSave","C-Space":"setMark","C-x C-x":"exchangePointAndMark","C-t":"transposeletters","M-u":"touppercase","M-l":"tolowercase","M-/":"autocomplete","C-u":"universalArgument","M-;":"togglecomment","C-/|C-x u|S-C--|C-z":"undo","S-C-/|S-C-x u|C--|S-C-z":"redo","C-x r":"selectRectangularRegion","M-x":{command:"focusCommandLine",args:"M-x "}},exports.handler.bindKeys(exports.emacsKeys),exports.handler.addCommands({recenterTopBottom:function(editor){var renderer=editor.renderer,pos=renderer.$cursorLayer.getPixelPosition(),h=renderer.$size.scrollerHeight-renderer.lineHeight,scrollTop=renderer.scrollTop;scrollTop=Math.abs(pos.top-scrollTop)<2?pos.top-h:Math.abs(pos.top-scrollTop-.5*h)<2?pos.top:pos.top-.5*h,editor.session.setScrollTop(scrollTop)},selectRectangularRegion:function(editor){editor.multiSelect.toggleBlockSelection()},setMark:{exec:function(editor,args){if(args&&args.count)return editor.inMultiSelectMode?editor.forEachSelection(moveToMark):moveToMark(),void moveToMark();var mark=editor.emacsMark(),ranges=editor.selection.getAllRanges(),rangePositions=ranges.map((function(r){return{row:r.start.row,column:r.start.column}})),hasNoSelection=ranges.every((function(range){return range.isEmpty()}));if(mark||!hasNoSelection)return editor.inMultiSelectMode?editor.forEachSelection({exec:editor.clearSelection.bind(editor)}):editor.clearSelection(),void(mark&&editor.pushEmacsMark(null));if(!mark)return rangePositions.forEach((function(pos){editor.pushEmacsMark(pos)})),void editor.setEmacsMark(rangePositions[rangePositions.length-1]);function moveToMark(){var mark=editor.popEmacsMark();mark&&editor.moveCursorToPosition(mark)}},readOnly:!0,handlesCount:!0},exchangePointAndMark:{exec:function(editor,args){var sel=editor.selection;if(args.count||sel.isEmpty())if(args.count){var pos={row:sel.lead.row,column:sel.lead.column};sel.clearSelection(),sel.moveCursorToPosition(editor.emacsMarkForSelection(pos))}else sel.selectToPosition(editor.emacsMarkForSelection());else sel.setSelectionRange(sel.getRange(),!sel.isBackwards())},readOnly:!0,handlesCount:!0,multiSelectAction:"forEach"},killWord:{exec:function(editor,dir){editor.clearSelection(),"left"==dir?editor.selection.selectWordLeft():editor.selection.selectWordRight();var range=editor.getSelectionRange(),text=editor.session.getTextRange(range);exports.killRing.add(text),editor.session.remove(range),editor.clearSelection()},multiSelectAction:"forEach"},killLine:function(editor){editor.pushEmacsMark(null),editor.clearSelection();var range=editor.getSelectionRange(),line=editor.session.getLine(range.start.row);range.end.column=line.length,line=line.substr(range.start.column);var foldLine=editor.session.getFoldLine(range.start.row);foldLine&&range.end.row!=foldLine.end.row&&(range.end.row=foldLine.end.row,line="x"),/^\s*$/.test(line)&&(range.end.row++,line=editor.session.getLine(range.end.row),range.end.column=/^\s*$/.test(line)?line.length:0);var text=editor.session.getTextRange(range);editor.prevOp.command==this?exports.killRing.append(text):exports.killRing.add(text),editor.session.remove(range),editor.clearSelection()},yank:function(editor){editor.onPaste(exports.killRing.get()||""),editor.keyBinding.$data.lastCommand="yank"},yankRotate:function(editor){"yank"==editor.keyBinding.$data.lastCommand&&(editor.undo(),editor.session.$emacsMarkRing.pop(),editor.onPaste(exports.killRing.rotate()),editor.keyBinding.$data.lastCommand="yank")},killRegion:{exec:function(editor){exports.killRing.add(editor.getCopyText()),editor.commands.byName.cut.exec(editor),editor.setEmacsMark(null)},readOnly:!0,multiSelectAction:"forEach"},killRingSave:{exec:function(editor){editor.$handlesEmacsOnCopy=!0;var marks=editor.session.$emacsMarkRing.slice(),deselectedMarks=[];exports.killRing.add(editor.getCopyText()),setTimeout((function(){function deselect(){var sel=editor.selection,range=sel.getRange(),pos=sel.isBackwards()?range.end:range.start;deselectedMarks.push({row:pos.row,column:pos.column}),sel.clearSelection()}editor.$handlesEmacsOnCopy=!1,editor.inMultiSelectMode?editor.forEachSelection({exec:deselect}):deselect(),editor.setEmacsMark(null),editor.session.$emacsMarkRing=marks.concat(deselectedMarks.reverse())}),0)},readOnly:!0},keyboardQuit:function(editor){editor.selection.clearSelection(),editor.setEmacsMark(null),editor.keyBinding.$data.count=null},focusCommandLine:function(editor,arg){editor.showCommandLine&&editor.showCommandLine(arg)}}),exports.handler.addCommands(iSearchCommandModule.iSearchStartCommands);var commands=exports.handler.commands;commands.yank.isYank=!0,commands.yankRotate.isYank=!0,exports.killRing={$data:[],add:function(str){str&&this.$data.push(str),this.$data.length>30&&this.$data.shift()},append:function(str){var idx=this.$data.length-1,text=this.$data[idx]||"";str&&(text+=str),text&&(this.$data[idx]=text)},get:function(n){return n=n||1,this.$data.slice(this.$data.length-n,this.$data.length).reverse().join("\n")},pop:function(){return this.$data.length>1&&this.$data.pop(),this.get()},rotate:function(){return this.$data.unshift(this.$data.pop()),this.get()}}})),ace.require(["ace/keyboard/emacs"],(function(m){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=m)}));